﻿'┌─────────┐
'│『ダイアルボタン』├───────────┐
'└┬──────┬─┘Programmed by はりまお│
'  │[SPEC]      └──────────┬──┘
'  │CPU      : Pentium M     (1.73GHz)│
'  │Memory   : 1GB                    │
'  │OS       : Windows XP             │
'  │             (Home Edition    SP3)│
'  │Language : Visual Basic 2010      │
'  │             (Express Edition SP1)│
'  └─────────────────┘

#Region "掲示板"
'┌────┐
'│技術要綱├──────────────────────
'└┬───┘
'  │『高（低）分解能ホイールへの対応』
'  │○Windows(XP)では、ホイールの回転（移動量）を120デルタという単位で捉えているようです。ホイールが回ると《.MouseWheel》イベントが発生し、回転量《e.Delta》として1ノッチ分なら-120または120が、更に高速連続回転なら240とか360とかが得られます。
'  │○なぜ"120"なのかというと、もし高（低）分解能のホイールが搭載されたマウスが登場した場合に対応するためだそうです。（それがどういう物なのか、実際に存在するのかは知りません。）
'  │●この状況に対応するために、以下の方法を採りました。
'  │  ├ 1. 《WheelDelta》プロパティを設けて、基準デルタ値を変更できるようにする。
'  │  └ 2. 《.MouseWheel》イベントで得られる《e.Delta》値を累積して、《WheelDelta》プロパティ値を満たした分を回転として処理し、余った分を次回以降に持ち越す。（もしかして、この処理をOS側でやってくれているのかも！？）
'  │※「ノッチ」とは、ホイールを回した時に“カチッカチッ”となる引っ掛かりのことです。正式名称は、知りません。
'  │
'  │『無段ホイールへの対応』
'  │○世の中のホイールには、回転する時に、ノッチが有る物（有段）と無い物（無段）が存在します。
'  │○無段ホイールでは、1ノッチ分の回転をユーザが認識するのは困難です。今回のように、ホイールを決まった分だけ回転させる必要がある場合、これでは困ってしまいます。
'  │●これに対応するために、以下の方法を採りました。
'  │  ├ 1. 基本的に、一方向に連続する回転は、1ノッチと考える。
'  │  ├ 2. 同じ方向に複数回回転する場合のために、回転が分離しているとを判断するための間隔（閾時間）を決める。「“回転→指を戻す→回転”という流れ」や「ある程度ゆっくり回しても過敏に反応しない」ことを考えると、250ミリ秒でちょうど良いと思う。
'  │  ├ 3. 前回の回転から今回の回転までを、《Stopwatch》クラスを使って計測し、閾時間以上空いていれば別の回転と判断する。
'  │  └ 4. ただし、「ダイヤルボタンにマウスカーソルが入った直後」や「回転方向が反転した時」は、閾時間に関係なく回転を分離する。
'  │・タッチパネル式のホイールにもこの処理で対処できると思うが、指を置いたり離したりする際に回転を認識してしまうようなことがあると上手く行かないかもしれない。そういうマウスを持っていないので検証できず。
'  │※「無段ホイール」とは、作者が勝手に付けた名前です。
'  │
'  │『無段ホイール モードの使い分け』
'  │○このフラグを切り替えると、入力イメージが以下のように変わります。
'  │・無効・・・主にノッチがあるホイールを使用する時。「上に3 下に1 上に2 …」と入力したい時に向く。実際のダイアル錠により近いかも（使ったことないから分からないけど）。
'  │・有効・・・主にノッチがない（感知し難い）ホイールを使用する時。「上下上上下…」と入力したい時に向く。大胆に入力できるので、こっちの方が簡単かも。
'  │
'  │『その他』
'  │○ステップが上限を超えた時に外部の音声ファイルを鳴らしたい場合に対応するため、《Alarm》プロパティを設けている。
'  │○状況に応じて前景色を変化させるのを、外部から行うのは大変なので、内部で強制的に行う。その代わり、色は選択可能とする。
'  └────────────
'┌───────┐
'│制作・改良履歴├───────────────────
'└┬──────┘
'  │「Ver.a.b.c.d」（小さい変化は、より大きい変化に含める）
'  │  a = 全体的に大きく変化した。作り直しなど。
'  │  b = 利用者にも見て分かる変更がある。機能の追加・削除、使用方法の変更など。
'  │  c = 機能的な変化はないが、内部的に作り変えた。処理方法の変更など。
'  │  d = その他、細かい修正。バグ修正など。
'  │
'  │2012年11月09日：Ver.1.0.3.0 ┬ ステップ数が最大数に達した時に、注意色になるようにした。
'  │                            └ 全使用色を変更可能にした。警告音の使用を選択可能にした。
'  │2012年11月04日：Ver.1.0.2.0 ─ 入力に対する基本的な反応を全て内包（利用するか選択可能）。
'  │2012年11月03日：Ver.1.0.1.1 ─ 無意味な処理があったので削除。
'  │2012年11月02日：Ver.1.0.1.0 ┬ 無段ホイールに対応。これに伴い、《NotchPattern》から《StepPattern》に変更。
'  │                            └ ステップパターンの入力プロセスを変更。
'  │2012年08月26日：Ver.1.0.0.4 ─ “やり直し”から“取り消す”に変更。“やり直し”だと、「入力しなおせ！」と言われているみたいなので。
'  │2012年02月25日：Ver.1.0.0.3 ─ キーでのダイアル入力に応急的に対応。
'  │2012年02月13日：Ver.1.0.0.2 ┬ 《NotchPattern》プロパティのSet処理を変更。
'  │                            └ ホイール回転認識処理手順の変更。
'  │2012年02月10日：Ver.1.0.0.1 ┬ 高解像度ホイールへ対応。※ただし、高解像の環境を持っていないので、これで解決できているのか不明。それに、1ノッチ分が判断し辛いので意味がないかも。
'  │                            └ マウスカーソルが乗っていない時、ホイールの回転を無視するのを失念していた。
'  │2012年02月07日：Ver.1.0.0.0 ─ とりあえず完成
'  │2012年02月03日：Ver.0.0.0.0 ─ 制作開始
'  └────────────
#End Region



Imports System.ComponentModel



''' <summary>
''' ダイアルボタン
''' </summary>
''' <remarks></remarks>
<DefaultProperty("StepPattern"),
 DefaultEvent("StepPatternChanged")> _
Public Class DialButton

    Inherits Button 'Buttonを継承



    '==============================================================



#Region "イベント定義"

    ''' <summary>
    ''' ステップパターンに変化があった
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    <Category("ステップパターン"),
     Description("ステップパターンが変更された時に発生します。")> _
    Public Event StepPatternChanged(ByVal sender As Object, ByVal e As EventArgs)

    ''' <summary>
    ''' ステップ数が上限を超えた
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    <Category("ステップパターン"),
     Description("ステップ数が上限を超えたときに発生します。")> _
    Public Event StepPatternOverflow(ByVal sender As Object, ByVal e As EventArgs)

#End Region



    '==============================================================



#Region "プロパティ定義"

    Private _StepPattern As String = "" '《StepPattern》用の記憶場所



    '--------------------------------------------------------------



    ''' <summary>テキストを取得・設定します</summary>
    <Browsable(False),
     ReadOnlyAttribute(True),
     DefaultValue("")> _
    Public Overloads Property Text As String

        Get
            Return MyBase.Text
        End Get

        Set(value As String)
            MyBase.Text = value
        End Set

    End Property

    ''' <summary>ダイアルのステップパターン</summary>
    <Category("ステップパターン"),
     Description("ダイアルのステップパターンです。"),
     DefaultValue("")> _
    Public Property StepPattern As String

        Get
            Return _StepPattern.ToUpper
        End Get

        Set(value As String)

            Dim befor As String = _StepPattern

            '=== ステップ数超過のチェックと調整 ===
            If value.Length > StepMaxLength Then
                _StepPattern = Strings.Left(value, StepMaxLength)
                RaiseEvent StepPatternOverflow(Me, New EventArgs)
            Else
                _StepPattern = value
            End If

            '=== ステップパターン変化チェック ===
            If _StepPattern <> befor Then
                RaiseEvent StepPatternChanged(Me, New EventArgs)
            End If

        End Set

    End Property

    ''' <summary>無段ホイール モード</summary>
    <Category("動作"),
     Description("無段ホイール モードを使用するかどうかを設定する。"),
     DefaultValue(False)> _
    Public Property SlipWheel As Boolean = False

    ''' <summary>1ノッチの移動量</summary>
    <Category("動作"),
     Description("1ノッチ分の移動量（Windowsの定数《WHEEL_DELTA》の値）を設定する。"),
     DefaultValue(120)> _
    Public Property WheelDelta As Integer = 120

    ''' <summary>回転分離閾時間</summary>
    <Category("動作"),
     Description("回転を分離する閾時間をミリ秒で設定する。"),
     DefaultValue(250)> _
    Public Property RollSeparateTime As Integer = 250

    ''' <summary>ステップ数の上限規制</summary>
    <Category("動作"),
     Description("ステップパターンに入力できる最大ステップ数を設定します。"),
     DefaultValue(32767)> _
    Public Property StepMaxLength As Integer = 32767

    ''' <summary>警告音</summary>
    <Category("動作"),
     Description("最大ステップ数を超えて入力しようとした時に警告音を鳴らすかどうかを設定します。"),
     DefaultValue(True)> _
    Public Property Alarm As Boolean = True

    ''' <summary>待機色</summary>
    <Category("色"),
     Description("入力対象ではない時の前景色。")> _
    Public Property StaticColor As Color = SystemColors.ControlText

    ''' <summary>点滅色1</summary>
    <Category("色"),
     Description("ホイールを回した時に、前景色を点滅させるための1つ目の色。")> _
    Public Property StepColor1 As Color = Color.Lime

    ''' <summary>点滅色2</summary>
    <Category("色"),
     Description("ホイールを回した時に、前景色を点滅させるための2つ目の色。")> _
    Public Property StepColor2 As Color = Color.LimeGreen

    ''' <summary>注意色</summary>
    <Category("色"),
     Description("最大ステップ数に達した時の前景色。")> _
    Public Property AttentionColor As Color = Color.Gold

    ''' <summary>警告色</summary>
    <Category("色"),
     Description("最大ステップ数超えて入力しようとした時の前景色。")> _
    Public Property CautionColor As Color = Color.Red

#End Region



    '==============================================================



    ''' <summary>上方回転</summary>
    Private Const RollUp As String = "U"

    ''' <summary>下方回転</summary>
    Private Const RollDown As String = "D"



    '==============================================================



    ''' <summary>マウスカーソルが乗っているかを示すフラグ</summary>
    Private HoveringFlag As Boolean = False

    ''' <summary>マウスカーソルが乗った直後であることを示すフラグ</summary>
    Private FirstStepFlag As Boolean = False

    ''' <summary>前回の残りDelta（高解像度ホイールへの対応）</summary>
    Private RemnantDelta As Integer = 0

    ''' <summary>回転分離用ストップウォッチ（無段ホイールへの対応）</summary>
    Private RollSeparateStopwatch As New Stopwatch



    '==============================================================



    ''' <summary>
    ''' コンストラクタ
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub New()

        MyBase.New()

        TextChange()

    End Sub

    Private Sub DialButton_MouseEnter(sender As Object, e As System.EventArgs) Handles Me.MouseEnter

        '=== マウスが入った ===
        HoveringFlag = True
        FirstStepFlag = True
        RemnantDelta = 0
        TextChange()

        Me.Select()
        Me.Font = New Font(Me.Font, Me.Font.Style Or FontStyle.Bold)

    End Sub

    Private Sub DialButton_MouseLeave(sender As Object, e As System.EventArgs) Handles Me.MouseLeave

        '=== マウスが出た ===
        HoveringFlag = False
        TextChange()

        RollSeparateStopwatch.Stop()

        Me.ForeColor = StaticColor
        Me.Font = New Font(Me.Font, Me.Font.Style Xor FontStyle.Bold)

    End Sub

    Private Sub DialButton_Click(sender As Object, e As System.EventArgs) Handles Me.Click

        '=== やり直し ===
        StepPattern = ""
        RemnantDelta = 0

    End Sub

    Private Sub DialButton_MouseWheel(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseWheel

        '=== ホイール回転 ===
        If HoveringFlag Then

            If SlipWheel Then

                '--- 無段（つるつる）ホイール用 ---
                '一定方向に一度に回転した分をまとめて1ノッチとみなす。
                If RollSeparateStopwatch.ElapsedMilliseconds > RollSeparateTime OrElse
                   FirstStepFlag OrElse
                   (StepPattern.Last = RollUp AndAlso e.Delta < 0 OrElse StepPattern.Last = RollDown AndAlso e.Delta > 0) Then
                    '「回転を分離する時間以上に間隔が空いた時」,「ダイアルボタン上にマウスが入った直後」,「回転方向が変わった時」だけ入力を認める。
                    '未入力時に直近のステップを抽出する（"StepPattern.Last"）とエラーになるので、その前に《FirstStepFlag》のチェックを必ず行う（未入力＝マウスが乗った直後）。

                    InputNotch(WheelDelta * Math.Sign(e.Delta))
                    FirstStepFlag = False

                End If

                RollSeparateStopwatch.Restart() '計測時間をリセット

            Else

                '--- 有段（かくかく）ホイール用 ---
                'ホイールの回転をそのまま入力する。
                InputNotch(e.Delta)

            End If

        End If

    End Sub

    Private Sub DialButton_KeyDown(sender As Object, e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown

        '=== キーでダイアルを操作するとき、強制的にマウスカーソルを移動 ===
        With DirectCast(sender, DialButton)
            Windows.Forms.Cursor.Position = .PointToScreen(New Point(.Width * 0.6, .Height * 0.6))
        End With

    End Sub

    Private Sub DialButton_KeyUp(sender As Object, e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyUp

        '=== キーでダイアルを回す ===
        '《KeyUp》イベントで行うのは、1ノッチずつ確実にキーを押させるため。
        Dim roll As Integer = 0 '回転方向

        Select Case e.KeyCode
            Case Keys.PageUp
                roll = WheelDelta
            Case Keys.PageDown
                roll = -WheelDelta
        End Select

        If roll <> 0 Then InputNotch(roll)

    End Sub

    ''' <summary>
    ''' ノッチ入力をステップパターンに登録
    ''' </summary>
    ''' <param name="Delta">回転情報</param>
    ''' <remarks></remarks>
    Private Sub InputNotch(Delta As Integer)

        '=== ステップパターン登録 ===
        If Math.Sign(RemnantDelta) <> Math.Sign(Delta) Then RemnantDelta = 0 '今までと今回の回転方向が逆の場合は、累積値をクリアする。
        RemnantDelta += Delta '前回の残りに今回分を足す。
        Dim data As Integer = RemnantDelta \ WheelDelta
        StepPattern &= Strings.StrDup(Math.Abs(data), IIf(Math.Sign(data) < 0, RollDown, RollUp))

        RemnantDelta = RemnantDelta Mod WheelDelta '半端分（WHEEL_DELTAに満たない分）を記憶

    End Sub

    Private Sub DialButton_StepPatternChanged(sender As Object, e As System.EventArgs) Handles Me.StepPatternChanged

        Static switch As Boolean = False '色切り替えスイッチ

        '=== 状態の変化を色でお知らせ ===
        If StepPattern = "" Then

            Me.ForeColor = StaticColor

        ElseIf StepPattern.Length = StepMaxLength Then

            Me.ForeColor = AttentionColor

        ElseIf HoveringFlag Then

            switch = Not switch
            Me.ForeColor = IIf(switch, StepColor1, StepColor2)

        End If

        '=== 表示変更 ===
        TextChange()

    End Sub

    Private Sub DialButton_StepPatternOverflow(sender As Object, e As System.EventArgs) Handles Me.StepPatternOverflow

        '=== もう満杯だよ！ ===
        DirectCast(sender, DialButton).ForeColor = CautionColor
        If Alarm Then My.Computer.Audio.PlaySystemSound(Media.SystemSounds.Beep)

    End Sub

    ''' <summary>
    ''' 《Text》プロパティを変更する
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub TextChange()

        If StepPattern = "" Then

            Text = "未入力"

        ElseIf StepPattern.Length = StepMaxLength Then

            Text = "満杯"

        Else

            If HoveringFlag Then
                Text = "取り消す"
            Else
                Text = "入力済み"
            End If

        End If

    End Sub

End Class
