﻿''' <summary>
''' 設定フォーム
''' </summary>
''' <remarks></remarks>
Public Class FormOption

    ''' <summary>変更箇所マスク</summary>
    Public Enum ChangedMask As Byte

        ''' <summary>なし</summary>
        [Nothing] = 0

        ''' <summary>ホバー展開時間</summary>
        HoverTime = 1

        ''' <summary>ランチメニュー登録フォルダの場所</summary>
        RegistryDirectoryPath = 2

        ''' <summary>ランチメニューの拡張子表示</summary>
        ShowExtension = 4

        ''' <summary>ランチメニューの大アイコン</summary>
        LargeIcon = 8

        ''' <summary>裏メニューの配置</summary>
        SecretMenuLocate = 16

        ''' <summary>鍵</summary>
        Key = 32

    End Enum



    '============================================================================================



    Private _ChangedFlag As ChangedMask = ChangedMask.Nothing

    ''' <summary>
    ''' 設定変更箇所フラグ
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property ChangedFlag As ChangedMask

        Get
            Return _ChangedFlag
        End Get

    End Property



    '============================================================================================



    Private Sub FormSetup_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

        '=== 初期設定 ===
        With hlpExplain
            .SetHelpString(btnOK, "設定内容を確定して保存します。" & vbCrLf & vbCrLf & "鍵に変更がある場合は、誤りがないか確認するための手続きが行われます。")
            .SetHelpString(btnCancel, "変更内容を破棄して、設定を終了します。")

            .SetHelpString(tajHoverPopupperInterval, "ここで指定した時間が経過するまで、タスクトレイのアイコンにマウスカーソルを乗せていると、ランチメニューが開きます。" & vbCrLf & vbCrLf & "※トラックバーのつまみを左端（0ミリ秒の位置）にすると、使用しないようになります。その際は、タスクトレイアイコンをクリックしてランチメニューを開いてください。")
            .SetHelpString(tajAutoCloserInterval, "ここで指定した時間が経過するまで、ランチメニューを放置すると、自動的に閉じられます。" & vbCrLf & vbCrLf & "・ホバー展開した時に作動します。" & vbCrLf & "・メニュー上にマウスカーソルがある間は、閉じられません。" & vbCrLf & "・作動中にキーボード操作を行うと、停止します。" & vbCrLf & vbCrLf & "※トラックバーのつまみを左端（0ミリ秒の位置）にすると、使用しないようになります。")

            Dim temp As String = "タスクバーの配置位置を指定することで、自動撤収機能が作動していることを示すタスクトレイアイコンの変化を変更します。" & vbCrLf & "これは、開いているランチメニューがアイコン内のゲージになるべく重ならないようにするためです。" & vbCrLf & vbCrLf & "『{0}』を指定した場合は、{1}します。"
            .SetHelpString(rdoTop, String.Format(temp, "上", "横方向に反転"))
            .SetHelpString(rdoRight, String.Format(temp, "右", "時計回りに90度回転"))
            .SetHelpString(rdoBottom, String.Format(temp, "下", "時計回りに180度回転"))
            .SetHelpString(rdoLeft, String.Format(temp, "左", "時計回りに270度回転"))

            .SetHelpString(txtRegistryPath, "ランチメニューにアイテムを登録・配置するためのフォルダを指定します。" & vbCrLf & vbCrLf & "※変更を確定した後に、旧フォルダの内容を新フォルダに移したり削除したり、適宜な作業を別途行ってください。")
            .SetHelpString(btnChoicePath, "フォルダを一覧から選択します。" & vbCrLf & "新規作成もできます。")

            .SetHelpString(nudLumpDepth, "ランチメニューを構築する時、その対象となるメニューより下へ何層分まとめて構築するかを指定します。" &
                           IIf(SystemSettings.LaunchMenu.MenuBuild.RecursiveCallMax = 0, "", String.Format("{0}{0}・ 0 なら、展開される層のアイテムのみを構築するので、読み込み時間を分散できます。{0}・ 1{1} なら、それだけ先読みして構築されるので、深い層へもいちいち待たされません。", vbCrLf, IIf(SystemSettings.LaunchMenu.MenuBuild.RecursiveCallMax = 1, "", "～" & SystemSettings.LaunchMenu.MenuBuild.RecursiveCallMax))))
            .SetHelpString(chkStartUpBuild, "ここにチェックを入れると、起動と共にランチメニューを構築するようになります。" & vbCrLf & vbCrLf & "※スタートアップに登録している場合、OSの起動の負担になるかもしれません。")

            .SetHelpString(chkBatchRun, "ここにチェックを入れると、ランチメニューの各層に[一括実行]項目が表示され、そこに格納されている全実行アイテムを実行できるようになります。")
            .SetHelpString(chkOpenSubDirectory, "ここにチェックを入れると、ランチメニューの各層に[登録・削除]項目が表示され、そこに対応するランチメニュー登録フォルダを開けられるようになります。")
            .SetHelpString(chkShowExtension, "ここにチェックを入れると、ランチメニューの各アイテム名に拡張子も表示されるようになります。")
            .SetHelpString(chkLargeIcon, "ここにチェックを入れると、ランチメニューに表示されるアイコンが大きくなります。")
            .SetHelpString(chkExCommandLineOption, "拡張コマンドライン引数モードは、[Ctrl]キーを押しながら実行アイテムを右クリックすることで使用しますが、ここにチェックを入れると、[Ctrl]キーを押した時と押さなかった時の動作が入れ替わります。")

            .SetHelpString(chkKeyChange, "鍵の 作成・変更・解除 を行いたい時に、チェックを入れます。" & vbCrLf & "その際、既に鍵が設定されている場合は、入力を求められます。" & vbCrLf & "変更を取り止めたい時は、チェックを外してください。" & vbCrLf & vbCrLf & "鍵には、""ダイヤル""と""合言葉""の2種類があり、両方でも片方だけでも利用できます。" & vbCrLf & vbCrLf & "設定した鍵は、裏メニューを開く（ランチメニューの裏アイテムを表示する）時に必要になります。")
            .SetHelpString(dbtnNewDial, String.Format("""ダイヤル""は、マウスのホイールの回転パターンを鍵に用います。{0}設定する場合は、ここに新しいパターンを、{1}ステップまでで入力します。{0}{0}入力には、マウスのホイールまたはキーボードの[Page Up]/[Page Down]キーを使用します。{0}入力を取り消したい時は、クリックしてください。{0}{0}※『未入力』のまま確定すると、解除されます。合言葉のみの変更であっても、現行ダイヤルの再入力が必要です。{0}※マウスカーソルが乗ると強制的にフォーカスを奪うので、他の項目を操作している時は注意してください。{0}※ホイールについては、[無段ホイール モード]のヘルプも参照してください。", vbCrLf, dbtnNewDial.StepMaxLength))
            .SetHelpString(txtNewPassword, String.Format("""合言葉""は、好きなパスワードを鍵に用います。{0}設定する場合は、ここに新しい文字列を、半角{1}文字までで入力します。{0}{0}※『空欄』のまま確定すると、解除されます。ダイヤルのみの変更であっても、現行の合言葉を再度入力する必要があります。", vbCrLf, txtNewPassword.MaxLength))
            .SetHelpString(chkSlipWheel, String.Format("ダイヤルの入力に、ノッチ（回転時に""カチッカチッ""となる引っ掛かり）がない{0}無段ホイールを使用する場合にチェックを入れます。{0}また、より手軽に入力したい場合にも有効です。{0}{0}この設定によって、入力する感覚が以下の様に変化します。{0}{0}[チェック有り]{0}一方向に連続する回転をまとめて1ステップとして認識します。{0}※{1}ミリ秒以上間隔が空くと、別のステップとなります。{0}「上下上上下…」という風に入力したい時に向く。{0}{0}[チェック無し]{0}1ノッチを1ステップとして認識します。{0}「下に2 上に3 下に1 …」という風に入力したい時に向く。", vbCrLf, SystemSettings.SecretMenu.MouseWheel.RollSeparateTime))

            .SetHelpString(rdoLaunchMenu, "裏メニューの開閉をランチメニューで行うようにします。")
            .SetHelpString(rdoSystemMenu, "裏メニューの開閉をシステムメニューで行うようにします。")
        End With

        '=== 現在値の反映 ===
        With SystemSettings

            '--- [タスクトレイ]タブ ---
            With .TaskTray

                '項目名の表示・・・ないと少し寂しい気がするし、あったらあったで狭苦しい。困ったもんだ。
                '詳細に表示したい時 → 《"作動待機時間　{0,8}ミリ秒（{1,7:0.000}秒）"》

                'ホバー展開
                With .HoverPopupper
                    tajHoverPopupperInterval.Initialize(.AdjustMax, .AdjustStep, .Time, "{0}ミリ秒")
                End With

                '自動撤収
                With .AutoCloser
                    tajAutoCloserInterval.Initialize(.AdjustMax, .AdjustStep, .Time, "{0}ミリ秒")

                    'タスクバーの配置場所
                    Select Case .IconRotate
                        Case RotateFlipType.RotateNoneFlipX
                            rdoTop.Checked = True
                        Case RotateFlipType.Rotate90FlipNone
                            rdoRight.Checked = True
                        Case RotateFlipType.Rotate180FlipNone
                            rdoBottom.Checked = True
                        Case RotateFlipType.Rotate270FlipNone
                            rdoLeft.Checked = True
                    End Select
                End With

            End With

            '--- [ランチメニュー]タブ ---
            With .LaunchMenu

                '登録フォルダ
                txtRegistryPath.Text = .RegistryPath

                'メニュー構築
                With .MenuBuild
                    chkStartUpBuild.Checked = .StartUpBuild
                    nudLumpDepth.Maximum = .RecursiveCallMax
                    nudLumpDepth.Value = .Depth
                    nudLumpDepth.Enabled = (.RecursiveCallMax > 0)
                End With

                'その他
                chkBatchRun.Checked = .BatchRun '一括起動
                chkOpenSubDirectory.Checked = .SubDirectoryOpener 'ランチメニュー登録サブフォルダ展開
                chkShowExtension.Checked = .ShowExtension '拡張子表示
                chkLargeIcon.Checked = .LargeIcon '大アイコン
                chkExCommandLineOption.Checked = .ExCommandLineOption '拡張コマンドライン引数

            End With

            '--- [裏メニュー]タブ ---
            With .SecretMenu

                With .MouseWheel
                    '無段ホイール モード
                    chkSlipWheel.Checked = .SlipWheelMode

                    'ダイヤル
                    dbtnNewDial.StepPattern = ""
                    dbtnNewDial.SlipWheel = .SlipWheelMode
                    dbtnNewDial.WheelDelta = .Delta
                    dbtnNewDial.RollSeparateTime = .RollSeparateTime
                End With

                '合言葉
                txtNewPassword.Text = ""

                '[裏メニュー]項目の設置場所
                Select Case .Locate
                    Case SystemParameter.SecretMenuParameter.LocateNo.LaunchMenu
                        rdoLaunchMenu.Checked = True
                        rdoSystemMenu.Checked = False
                    Case SystemParameter.SecretMenuParameter.LocateNo.SystemMenu
                        rdoLaunchMenu.Checked = False
                        rdoSystemMenu.Checked = True
                End Select

            End With

        End With

    End Sub

    Private Sub btnOk_Click(sender As System.Object, e As System.EventArgs) Handles btnOK.Click

        '=== 確定 ===
        Dim keyChangeFlag As Boolean = False '鍵の変更認可フラグ

        '--- 整合性チェック ---
        '鍵
        If chkKeyChange.Checked Then '鍵の変更意思があるか？

            If dbtnNewDial.StepPattern = "" AndAlso txtNewPassword.Text = "" Then

                '鍵の解除確認
                keyChangeFlag = (MessageBox.Show("鍵が、解除されます。よろしいですか？", Me.Text & " - [鍵の解除]",
                                                 MessageBoxButtons.OKCancel,
                                                 MessageBoxIcon.Exclamation,
                                                 MessageBoxDefaultButton.Button2) = Windows.Forms.DialogResult.OK) '《MessageBoxIcon.Question》を使う予定が、「使うな」ってことなので。

            Else

                '新鍵の確認
                Dim inputKeyForm As New FormKey("鍵が、変更されています。" & vbCrLf & "確認のため、新しい鍵をもう一度入力してください。", dbtnNewDial.StepPattern, txtNewPassword.Text, True) With {.Text = Me.Text & " - [鍵の変更]", .Icon = Me.Icon, .StartPosition = FormStartPosition.CenterParent}
                keyChangeFlag = (inputKeyForm.ShowDialog(Me, chkSlipWheel.Checked) = Windows.Forms.DialogResult.OK)
                inputKeyForm.Dispose()

            End If

            If Not keyChangeFlag Then
                '設定に戻る
                Me.DialogResult = Windows.Forms.DialogResult.None 'フォームが勝手に閉じるのを防ぐ（[OK]/[キャンセル]ボタンの《.DialogResult》プロパティを設定しているため、自動的に閉じられる）。
                Exit Sub '※※※
            End If

        End If

        'ランチメニュー登録フォルダの存在チェック（フォルダ名が変更されるなど何らかの理由で消失している場合に対処するため、パスの変更がなくても確認する）
        If Not DirectCast(Owner, FormMain).LaunchMenuExistenceCheck(txtRegistryPath.Text) Then
            'やり直し
            Me.DialogResult = Windows.Forms.DialogResult.None 'フォームが勝手に閉じるのを防ぐ（[OK]/[キャンセル]ボタンの《.DialogResult》プロパティを設定しているため、自動的に閉じられる）。
            TabControl1.SelectedTab = tabLaunchMenu
            With txtRegistryPath
                .Text = SystemSettings.LaunchMenu.RegistryPath
                .Focus()
                .SelectAll()
            End With
            Exit Sub '※※※
        End If

        '--- 変更内容をシステム設定パラメータに反映する ---
        'ホバー展開時間
        If CInt(tajHoverPopupperInterval.Value) <> SystemSettings.TaskTray.HoverPopupper.Time Then
            SystemSettings.TaskTray.HoverPopupper.Time = CInt(tajHoverPopupperInterval.Value)
            _ChangedFlag = _ChangedFlag Or ChangedMask.HoverTime
        End If

        '自動撤収
        SystemSettings.TaskTray.AutoCloser.Time = CInt(tajAutoCloserInterval.Value)

        'タスクバーの配置場所
        Select Case True
            Case rdoTop.Checked
                SystemSettings.TaskTray.AutoCloser.IconRotate = RotateFlipType.RotateNoneFlipX
            Case rdoRight.Checked
                SystemSettings.TaskTray.AutoCloser.IconRotate = RotateFlipType.Rotate90FlipNone
            Case rdoBottom.Checked
                SystemSettings.TaskTray.AutoCloser.IconRotate = RotateFlipType.Rotate180FlipNone
            Case rdoLeft.Checked
                SystemSettings.TaskTray.AutoCloser.IconRotate = RotateFlipType.Rotate270FlipNone
        End Select

        'ランチメニュー登録フォルダ
        If txtRegistryPath.Text <> SystemSettings.LaunchMenu.RegistryPath Then
            SystemSettings.LaunchMenu.RegistryPath = txtRegistryPath.Text
            _ChangedFlag = _ChangedFlag Or ChangedMask.RegistryDirectoryPath
        End If

        '起動時にメニュー構築
        SystemSettings.LaunchMenu.MenuBuild.StartUpBuild = chkStartUpBuild.Checked

        '一括構築深度
        SystemSettings.LaunchMenu.MenuBuild.Depth = nudLumpDepth.Value

        '一括実行
        SystemSettings.LaunchMenu.BatchRun = chkBatchRun.Checked

        'ランチメニュー登録サブフォルダ展開
        SystemSettings.LaunchMenu.SubDirectoryOpener = chkOpenSubDirectory.Checked

        '拡張子表示
        If chkShowExtension.Checked <> SystemSettings.LaunchMenu.ShowExtension Then
            SystemSettings.LaunchMenu.ShowExtension = chkShowExtension.Checked
            _ChangedFlag = _ChangedFlag Or ChangedMask.ShowExtension
        End If

        '大アイコン
        If chkLargeIcon.Checked <> SystemSettings.LaunchMenu.LargeIcon Then
            SystemSettings.LaunchMenu.LargeIcon = chkLargeIcon.Checked
            _ChangedFlag = _ChangedFlag Or ChangedMask.LargeIcon
        End If

        '拡張コマンドライン引数
        SystemSettings.LaunchMenu.ExCommandLineOption = chkExCommandLineOption.Checked

        '[裏メニュー]項目設置場所
        If rdoLaunchMenu.Checked AndAlso SystemSettings.SecretMenu.Locate = SystemParameter.SecretMenuParameter.LocateNo.SystemMenu Then
            SystemSettings.SecretMenu.Locate = SystemParameter.SecretMenuParameter.LocateNo.LaunchMenu
            _ChangedFlag = _ChangedFlag Or ChangedMask.SecretMenuLocate
        ElseIf rdoSystemMenu.Checked AndAlso SystemSettings.SecretMenu.Locate = SystemParameter.SecretMenuParameter.LocateNo.LaunchMenu Then
            SystemSettings.SecretMenu.Locate = SystemParameter.SecretMenuParameter.LocateNo.SystemMenu
            _ChangedFlag = _ChangedFlag Or ChangedMask.SecretMenuLocate
        End If

        '鍵
        If keyChangeFlag Then
            KeySettings.Password = txtNewPassword.Text
            KeySettings.Dial = dbtnNewDial.StepPattern
            _ChangedFlag = _ChangedFlag Or ChangedMask.Key
        End If

        '無段ホイール モード
        SystemSettings.SecretMenu.MouseWheel.SlipWheelMode = chkSlipWheel.Checked

    End Sub

    Private Sub btnChoicePath_Click(sender As System.Object, e As System.EventArgs) Handles btnChoicePath.Click

        '=== ランチメニュー登録フォルダを選択 ===
        Dim fbd As New FolderBrowserDialog With {.Description = "新しい「ランチメニュー登録フォルダ」を選択してください。",
                                                 .SelectedPath = txtRegistryPath.Text}
        With fbd

            '--- ダイアログ表示 ---
            If .ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
                txtRegistryPath.Text = .SelectedPath
            End If

            .Dispose()
        End With

    End Sub

    Private Sub chkKeyChange_CheckedChanged(sender As Object, e As System.EventArgs) Handles chkKeyChange.CheckedChanged

        '=== 鍵変更の意思表明 ===
        With DirectCast(sender, CheckBox)

            If .Checked Then

                '--- 現行鍵の照合 ---
                If KeySettings.Password & KeySettings.Dial <> "" Then

                    .CheckState = CheckState.Indeterminate '保留

                    '入力
                    Dim inputKeyForm As New FormKey("現在設定されている鍵を入力してください。") With {.Text = Me.Text & " - [鍵の変更]", .Icon = Me.Icon, .StartPosition = FormStartPosition.CenterParent}
                    .CheckState = IIf(inputKeyForm.ShowDialog(Me, chkSlipWheel.Checked) = Windows.Forms.DialogResult.OK, CheckState.Checked, CheckState.Unchecked)
                    inputKeyForm.Dispose()

                End If

                '認証
                If .Checked Then
                    tlpNewKey.Enabled = True
                    btnOK.Text = "OK..."
                End If

            Else

                '--- 意思の取り下げ ---
                tlpNewKey.Enabled = False
                btnOK.Text = "OK"

            End If

        End With

    End Sub

    Private Sub chkSlipWheel_CheckedChanged(sender As Object, e As System.EventArgs) Handles chkSlipWheel.CheckedChanged

        '=== 無段ホイール モードの切り替え ===
        dbtnNewDial.SlipWheel = DirectCast(sender, CheckBox).Checked

    End Sub
End Class