﻿''' <summary>
''' ラベル付ステップ式トラックバー
''' </summary>
''' <remarks></remarks>
Public Class StepTrackBar

    ''' <summary>
    ''' 1目盛りあたりの数値を取得・設定する
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property AdjustStep As Integer = 1

    ''' <summary>
    ''' 調整された数値を取得する
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property Value As Integer

        Get
            Return TrackBar.Value * AdjustStep
        End Get

    End Property



    '============================================================================================



    Private Sub TrackBar_Scroll(sender As System.Object, e As System.EventArgs) Handles TrackBar.Scroll

        '=== 調整値を表示 ===
        PrintValue()

    End Sub

    ''' <summary>
    ''' 初期化
    ''' </summary>
    ''' <param name="Max">最大値</param>
    ''' <param name="Step">調整間隔</param>
    ''' <param name="Init">初期値</param>
    ''' <param name="Format">書式</param>
    ''' <remarks></remarks>
    Public Sub Initialize(Max As Integer, [Step] As Integer, Init As Integer, Optional Format As String = "{0}")

        With TrackBar
            .Maximum = Math.Ceiling(Max / [Step])
            .Value = Math.Ceiling(Init / [Step])
            Me.Enabled = (.Maximum > 0)
        End With
        AdjustStep = [Step]
        Label.Tag = Format
        PrintValue()

    End Sub

    ''' <summary>
    ''' 現在の値を《Label》に表示する
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub PrintValue()

        If Value > 0 Then
            Label.Text = String.Format(Label.Tag, Value, Value / 1000)
        Else
            Label.Text = "切"
        End If

    End Sub

End Class
